class Stream
  attr_accessor :sa_list, :pkt_num, :plist
  def initialize(src, dst)
    @pkt_num = 0
    @src_host = src
    @dst_host = dst
    @sa_list = []
    @plist = []
  end

  def add_packet(p)
    @sa_list.unshift(p.seq_num) unless @sa_list.include?(p.seq_num)
    @sa_list.unshift(p.ack_num) unless @sa_list.include?(p.ack_num)
    @pkt_num = @pkt_num + 1
    @plist.push(p)
  end

  def get_src_plist
    slist = []
    plist.collect { |p| slist.push(p) if p.ip_src == @src_host; }
    return slist
  end

  def get_dst_plist
    dlist = []
    plist.collect { |p| dlist.push(p) if p.ip_src == @dst_host; }
    return dlist
  end

end
