#!/usr/bin/env ruby
require 'pcaplet'
p = Pcap::Capture.open_offline(ARGV[0])
o = Pcap::Dumper.open(p,ARGV[1])
flows={}
p.each do |pkt|
  key = [pkt.ip_src,pkt.sport,pkt.dport,pkt.ip_dst]
  rkey = key.reverse
  key = rkey if flows[rkey]
  flows[key] = {'pkts'=>[]} unless flows[key]
  if pkt.tcp_syn? and pkt.tcp_ack?
    flows[key]['synack'] = pkt
  elsif pkt.tcp_syn?
    flows[key]['syn'] = pkt
  elsif pkt.tcp_fin? and pkt.tcp_ack?
    flows[key]['finack'] = pkt
  elsif pkt.tcp_fin?
    flows[key]['fin'] = pkt
  else
    #flows[key]['pkts'] += [pkt]
    if flows[key]['pkts'].nil?
      flows[key]['pkts'] = []
    end
    flows[key]['pkts'].push(pkt)
    puts "pushed, len: #{flows[key]['pkts'].length}"
  end
end
flows.each do |key,buffer|
  #buffer['syn'].time = Time.now
  o.dump(buffer['syn'])
  #buffer['synack'].time = Time.now
  o.dump(buffer['synack'])
  puts "dump length: #{buffer['pkts'].length}"
  buffer['pkts'].sort {rand}.each do |pkt|
    #pkt.time = Time.now
    o.dump(pkt)
  end
  #buffer['fin'].time = Time.now  if buffer['fin']
  o.dump(buffer['fin']) unless buffer['fin'].nil?
  #buffer['finack'].time = Time.now if buffer['finack']
  o.dump(buffer['finack']) unless buffer['finack'].nil?
end
o.close

