#!/usr/bin/env ruby
#
# Copyright 2008 Matthew Lee Hinman
#
# Simply print the packets, with stream details
# 
# Usage: ./sdump.rb <pcapfile>

require 'lib/pcapparser.rb'

p = PcapParser.new(File.new(ARGV[0]))

pcount = 0

p.each { |pkt|
  pcount = pcount + 1
  next unless pkt.tcp?

  print "[#{pcount}]\t[#{pkt.readable_flags}] "
  print [pkt.ip_src].pack("N").unpack("C4").join(".")
  print " -> "
  print [pkt.ip_dst].pack("N").unpack("C4").join(".")
  print "\tseq=#{pkt.seq_num} ack=#{pkt.ack_num} len=#{pkt.length}"
  print "\n"
}
